
#include "i2c.h"

#ifdef DEBUG_I2C_C

void isotime(char* buf, size_t buflen, time_t _t)
{
	struct tm *t;

	if (buflen>=19) 
	{
	t = localtime(&_t);
	sprintf(buf, "%d-%02d-%02d %02d:%02d:%02d", 
		t->tm_year+1900, t->tm_mon+1, t->tm_mday, t->tm_hour, t->tm_min, t->tm_sec);
	}
}

void configure_DS1625(I2CContext *pc, unsigned char addr)
{
	unsigned char command, config;
	unsigned char s[2];

	command = 0xac; // access config
	I2CTransmitData(pc, TRUE, addr, 1, &command);
	I2CReceiveData(pc, addr, 1, &config);
	printf("addr=%x, config=%x\n", addr, config);
	config &= ~1; // clear 1shot bit
	printf("addr=%x, new config=%x\n", addr, config);
	s[0] = command;
	s[1] = config;
	if (!I2CTransmitData(pc, TRUE, addr, 2, s))
		printf("  data write failed\n");

	//I2CTransmitData(pc, TRUE, addr, 1, &command);
	I2CReceiveData(pc, addr, 1, &config);
	printf("addr=%x, config=%x\n", addr, config);
	//I2CTransmitData(pc, TRUE, addr, 1, &command);
	I2CReceiveData(pc, addr, 1, &config);
	printf("addr=%x, config=%x\n", addr, config);
	Sleep(300);
	I2CTransmitData(pc, TRUE, addr, 1, &command);
	I2CReceiveData(pc, addr, 1, &config);
	printf("addr=%x, config=%x\n", addr, config);
	Sleep(300);

	command = 0xee; // start convert
	I2CTransmitData(pc, TRUE, addr, 1, &command);
}

float read_DS1625_temp(I2CContext *pc, unsigned char addr)
{
	unsigned char command;
	short temp;

	command = 0xaa; // read temp
	I2CTransmitData(pc, FALSE, addr, 1, &command);
	I2CReceiveData(pc, addr, sizeof(temp), &temp);
	command = temp>>8;
	temp = temp<<8;
	temp = temp | command;
	return temp/(float)256.0;
}

int main()
{
	I2CContext h;

	if (!I2COpen(TEXT("com1"), &h)) {
		printf("Unable to open port\n");
		return 1;
	}

	I2CStop(&h);

	configure_DS1625(&h, 0x90);
	configure_DS1625(&h, 0x92);
d:
	{
		time_t ltime;
		struct tm *t;
		char times[128];

		ltime = time(0);
		t = localtime(&ltime);
		isotime(times, sizeof(times), ltime);
		
		/* command = 0xee;
		I2CTransmitData(&h, TRUE, 0x90, 1, &command);
		command = 0xee;
		I2CTransmitData(&h, TRUE, 0x92, 1, &command);*/

		printf("%s temp1: %.1f temp2: %.1f\n", times, read_DS1625_temp(&h, 0x90), read_DS1625_temp(&h, 0x92));
		Sleep(300000);
	}

	//Sleep(5000);

	if (!kbhit())
		goto d;

	I2CClose(&h);

	return 0;
}

#endif
